import javax.naming.*;
import javax.naming.directory.*;

import java.util.Hashtable;

/**
 * Demonstrates how to an entry's list of attributes without their values
 *
 * usage: java GetTypesOnly
 */
class GetTypesOnly {
    public static void main(String[] args) {


	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	// Indicate that we only want the type names
	env.put("java.naming.ldap.typesOnly", "true");

	try {
	    // Create initial context
	    DirContext ctx = new InitialDirContext(env);

	    // Get the attributes
	    Attributes attrs = ctx.getAttributes("cn=Ted Geisel, ou=People");

	    // Print the answer
	    System.out.println(attrs);
	} catch (NamingException e) {
	    e.printStackTrace();
	}
    }
}
