import javax.naming.*;
import javax.naming.directory.*;
import java.util.Hashtable;

/**
  * Demonstrates how to create a referral entry.
  *
  * usage: java CheckReferral [follow]
  */
class CheckReferral {
    public static void main(String[] args) {

	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:489/o=JNDITutorial");

	// Set follow referral if we're interested in what's referenced
	if (args.length == 1) {
	    env.put(Context.REFERRAL, "follow");
	} else {
	    // Optional because "ignore" is the default
	    env.put(Context.REFERRAL, "ignore");

	    // Uncomment this line when using 1.0.1 
	    // env.put("java.naming.ldap.control.manageReferral", "true");
	} 

	try {
	    // Create the initial context
	    DirContext ctx = new InitialDirContext(env);

	    // See its attributes
	    Attributes attrs = ctx.getAttributes("cn=NewReferral");

	    System.out.println(attrs);
	} catch (NamingException e) {
	    e.printStackTrace();
	}
    }
}
